//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Generator.Test.TestReference
{


    /// <summary>
    /// A class that exposes the IInlineObservableService interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute( typeof( IFeatureProvider ) )]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute( System.ComponentModel.Composition.CreationPolicy.Shared )]
    public partial class InlineObservableServiceProvider : IFeatureProvider
    {

        private IInlineObservableService _implementation;

        private Tecan.Sila2.Server.ISiLAServer _server;

        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly( typeof( InlineObservableServiceProvider ).Assembly, "InlineObservableService.sila.xml" );

        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public InlineObservableServiceProvider( IInlineObservableService implementation, Tecan.Sila2.Server.ISiLAServer server )
        {
            _implementation = implementation;
            _server = server;
        }

        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }

        private System.Exception ConvertTestInlineObservableExceptions( System.Exception exception )
        {
            try
            {
                throw exception;
            }
            catch(System.ArgumentException ex)
            {
                if((ex.ParamName == "parameter"))
                {
                    throw _server.ErrorHandling.CreateValidationError( "tecan.sila.generator.test/testreference/InlineObservableService/v4/Command/TestIn" +
                            "lineObservable/Parameter/Parameter", ex.Message );
                }
                throw _server.ErrorHandling.CreateUnknownValidationError( ex );
            }
        }

        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register( IServerBuilder registration )
        {
            registration.RegisterObservableCommand<TestInlineObservableRequestDto, bool, TestInlineObservableResponseDto>( "TestInlineObservable", TestInlineObservable, ConvertTestInlineObservableResponse, ConvertTestInlineObservableExceptions );
        }

        private TestInlineObservableResponseDto ConvertTestInlineObservableResponse( bool result )
        {
            return new TestInlineObservableResponseDto( result, _server );
        }

        /// <summary>
        /// Executes the Test Inline Observable command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IObservableCommand<bool> TestInlineObservable( TestInlineObservableRequestDto request )
        {
            request.Validate();
            return new TestInlineObservableCommand( this, request );
        }

        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand( string commandIdentifier )
        {
            if((commandIdentifier == "tecan.sila.generator.test/testreference/InlineObservableService/v4/Command/TestIn" +
                "lineObservable"))
            {
                return typeof( IInlineObservableService ).GetMethod( "TestInlineObservable" );
            }
            return null;
        }

        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty( string propertyIdentifier )
        {
            return null;
        }

        private class TestInlineObservableCommand : Tecan.Sila2.ObservableCommand<bool>
        {

            private InlineObservableServiceProvider _parent;

            private TestInlineObservableRequestDto _request;

            public TestInlineObservableCommand( InlineObservableServiceProvider parent, TestInlineObservableRequestDto request ) :
                    base( new System.Threading.CancellationTokenSource() )
            {
                _parent = parent;
                _request = request;
            }

            public override System.Threading.Tasks.Task<bool> Run()
            {
                return System.Threading.Tasks.Task.Factory.StartNew( RunCore, CancellationToken );
            }

            private bool RunCore()
            {
                return _parent._implementation.TestInlineObservable( _request.Parameter.TryExtract( _parent._server, "tecan.sila.generator.test/testreference/InlineObservableService/v4/Command/TestIn" +
                            "lineObservable/Parameter/Parameter" ), CancellationToken );
            }
        }
    }
}

